## ppsspp 1.19.3

=== ext/CMakeLists.txt ===
set(ARMIPS_REGEXP OFF CACHE BOOL "" FORCE)
set(ARMIPS_LIBRARY_ONLY ON CACHE BOOL "" FORCE)
if(WIN32)
	set(ARMIPS_USE_STD_FILESYSTEM ON CACHE BOOL "" FORCE)
endif()

if(USE_ARMIPS)
	add_subdirectory(armips)
endif()
if(NOT USING_GLES2)
	add_subdirectory(glew)
endif()

set(ENABLE_GLSLANG_BINARIES OFF CACHE BOOL "let's not build binaries we don't need" FORCE)
set(SPIRV_CROSS_EXCEPTIONS_TO_ASSERTIONS ON CACHE BOOL "let's not use exceptions" FORCE)
set(ENABLE_SPVREMAPPER OFF CACHE BOOL "we don't need spvremapper" FORCE)

# This is really a workaround for an NDK 20 compiler issue (PPSSPP issue #12105), but shouldn't hurt.
if(ANDROID)
set(ENABLE_HLSL OFF CACHE BOOL "let's not build HLSL support we don't need" FORCE)
endif()

# This works around a bug in cpu_features when ${CMAKE_BINARY_DIR} != ${CMAKE_CURRENT_BINRARY_DIR}.
# We also disable the list_cpu_features binary.
add_subdirectory(cmake/cpu_features EXCLUDE_FROM_ALL)

set(SKIP_GLSLANG_INSTALL ON CACHE BOOL "" FORCE)
set(ENABLE_GLSLANG_INSTALL OFF)
add_subdirectory(glslang EXCLUDE_FROM_ALL)
add_subdirectory(snappy)
add_subdirectory(lua-build)
add_subdirectory(minimp3)
add_subdirectory(at3_standalone)
add_subdirectory(udis86)
add_subdirectory(SPIRV-Cross-build)
add_subdirectory(rcheevos-build)
if(NOT LIBRETRO)
    add_subdirectory(imgui)
endif()
if(NOT HTTPS_NOT_AVAILABLE)
	add_subdirectory(naett-build)
endif()
if(USE_DISCORD AND NOT IOS AND NOT LIBRETRO)
	add_subdirectory(discord-rpc-build)
endif()

add_subdirectory(libchdr-build)

if(ANDROID)
    if (ARM64)
        add_subdirectory(libadrenotools)
    endif()
endif()

=== libretro/CMakeLists.txt ===

set(LIBRETRO_SRCS
	libretro.cpp
	LibretroGraphicsContext.cpp
	LibretroGLContext.cpp
	LibretroGLCoreContext.cpp
	LibretroVulkanContext.cpp
	libretro_vulkan.cpp)

if(WIN32)
	set(LIBRETRO_SRCS ${LIBRETRO_SRCS}
		LibretroD3D11Context.cpp)
endif()

include_directories(libretro)

add_library(ppsspp_libretro SHARED ${LIBRETRO_SRCS})
set(LIBRARY_OUTPUT_PATH "${CMAKE_BINARY_DIR}")
set_target_properties(ppsspp_libretro PROPERTIES PREFIX "")
if(ANDROID)
	set_target_properties(ppsspp_libretro PROPERTIES SUFFIX "_android.so")
endif()

if(NOT MSVC)
   if (APPLE OR IOS)
   	target_link_libraries(ppsspp_libretro objc "-Wl,-exported_symbols_list,${CMAKE_CURRENT_SOURCE_DIR}/libretro.osx.def")
   else()
   	target_link_libraries(ppsspp_libretro "-Wl,-Bsymbolic")
   endif()
endif()
target_link_libraries(ppsspp_libretro ${LinkCommon})

=== ext/SPIRV-Cross-build/CMakeLists.txt ===
# Copyright 2016 Google Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

cmake_minimum_required(VERSION 3.10)
project(SPIRV-Cross)
enable_testing()

option(SPIRV_CROSS_EXCEPTIONS_TO_ASSERTIONS "Instead of throwing exceptions assert" ON)

set(SRCDIR "${CMAKE_CURRENT_SOURCE_DIR}/../SPIRV-Cross")

add_library(spirv-cross-core STATIC
		${SRCDIR}/GLSL.std.450.h
		${SRCDIR}/spirv_common.hpp
		${SRCDIR}/spirv.hpp
		${SRCDIR}/spirv_cross.hpp
		${SRCDIR}/spirv_cross.cpp
		${SRCDIR}/spirv_cross_containers.hpp
		${SRCDIR}/spirv_cross_error_handling.hpp
		${SRCDIR}/spirv_cross_util.hpp
		${SRCDIR}/spirv_cross_util.cpp
		${SRCDIR}/spirv_cfg.hpp
		${SRCDIR}/spirv_cfg.cpp
		${SRCDIR}/spirv_cross_parsed_ir.hpp
		${SRCDIR}/spirv_cross_parsed_ir.cpp
		${SRCDIR}/spirv_parser.hpp
		${SRCDIR}/spirv_parser.cpp)

add_library(spirv-cross-glsl STATIC
		${SRCDIR}/spirv_glsl.cpp
		${SRCDIR}/spirv_glsl.hpp)

add_library(spirv-cross-cpp STATIC
		${SRCDIR}/spirv_cpp.hpp
		${SRCDIR}/spirv_cpp.cpp)

add_library(spirv-cross-msl STATIC
		${SRCDIR}/spirv_msl.hpp
		${SRCDIR}/spirv_msl.cpp)

add_library(spirv-cross-hlsl STATIC
		${SRCDIR}/spirv_hlsl.hpp
		${SRCDIR}/spirv_hlsl.cpp)

	#add_executable(spirv-cross main.cpp)
	#target_link_libraries(spirv-cross spirv-cross-glsl spirv-cross-cpp spirv-cross-msl spirv-cross-hlsl spirv-cross-core)
target_link_libraries(spirv-cross-glsl spirv-cross-core)
target_link_libraries(spirv-cross-msl spirv-cross-glsl)
target_link_libraries(spirv-cross-cpp spirv-cross-glsl)
target_link_libraries(spirv-cross-hlsl spirv-cross-glsl)
target_include_directories(spirv-cross-core PUBLIC ${SRCDIR})

set(spirv-compiler-options "")
set(spirv-compiler-defines "")

if(SPIRV_CROSS_EXCEPTIONS_TO_ASSERTIONS)
  set(spirv-compiler-defines ${spirv-compiler-defines} SPIRV_CROSS_EXCEPTIONS_TO_ASSERTIONS)
endif()

# To specify special debug or optimization options, use
# -DCMAKE_CXX_COMPILE_FLAGS
# However, we require the C++11 dialect.
if (NOT "${MSVC}")
  set(spirv-compiler-options ${spirv-compiler-options})
  set(spirv-compiler-defines ${spirv-compiler-defines} __STDC_LIMIT_MACROS)

  if(SPIRV_CROSS_EXCEPTIONS_TO_ASSERTIONS)
    set(spirv-compiler-options ${spirv-compiler-options} -fno-exceptions)
  endif()
endif()

target_compile_options(spirv-cross-core PRIVATE ${spirv-compiler-options})
target_compile_options(spirv-cross-glsl PRIVATE ${spirv-compiler-options})
target_compile_options(spirv-cross-msl PRIVATE ${spirv-compiler-options})
target_compile_options(spirv-cross-cpp PRIVATE ${spirv-compiler-options})
target_compile_options(spirv-cross-hlsl PRIVATE ${spirv-compiler-options})
target_compile_definitions(spirv-cross-core PRIVATE ${spirv-compiler-defines})
target_compile_definitions(spirv-cross-glsl PRIVATE ${spirv-compiler-defines})
target_compile_definitions(spirv-cross-msl PRIVATE ${spirv-compiler-defines})
target_compile_definitions(spirv-cross-cpp PRIVATE ${spirv-compiler-defines})
target_compile_definitions(spirv-cross-hlsl PRIVATE ${spirv-compiler-defines})

=== ext/armips/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(armips) 

option(ARMIPS_PRECOMPILE_HEADERS "Use precompiled headers" OFF)
option(ARMIPS_REGEXP "Enable regexp expression functions" ON)
option(ARMIPS_USE_STD_FILESYSTEM "Use std::filesystem instead of third party implementation" OFF)
option(ARMIPS_LIBRARY_ONLY "Build libarmips, skip building armips and armipstests binaries" OFF)

macro(check_compiler VARIABLE NAME)
	if (${CMAKE_CXX_COMPILER_ID} MATCHES ${NAME})
		set(${VARIABLE} TRUE)
	else()
		set(${VARIABLE} FALSE)
	endif()
endmacro()

check_compiler(CLANG "Clang")
check_compiler(GCC "GNU")

# Helper function to set common parameters for a target
function(init_target TARGET_NAME)
	set_target_properties(${TARGET_NAME} PROPERTIES
		CXX_STANDARD 17
		CXX_STANDARD_REQUIRED TRUE
		CXX_EXTENSIONS FALSE)

	target_include_directories(${TARGET_NAME} BEFORE PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})

	if (GCC OR CLANG)
		# clang-cl seems to treat -Wall as -Weverything
		if (NOT MSVC)
			target_compile_options(${TARGET_NAME} PRIVATE -Wall)
		endif()

		target_compile_options(${TARGET_NAME} PRIVATE -Wno-unused-parameter)

		if (NOT MSVC AND NOT ${CMAKE_SYSTEM_NAME} MATCHES "Haiku" AND NOT WIIU)
			find_package(Threads REQUIRED)
			target_link_libraries(${TARGET_NAME} PRIVATE Threads::Threads)
		endif()
	endif ()

	if (ARMIPS_REGEXP)
		target_compile_definitions(${TARGET_NAME} PRIVATE ARMIPS_REGEXP=1)
	endif()

	if (WIN32)
		if (MSVC)
			target_compile_options(${TARGET_NAME} PRIVATE /Zc:__cplusplus)
			target_compile_options(${TARGET_NAME} PRIVATE /permissive-)
			target_compile_definitions(${TARGET_NAME} PRIVATE UNICODE _UNICODE)
			target_compile_definitions(${TARGET_NAME} PRIVATE _CRT_SECURE_NO_WARNINGS)
		else()
			target_compile_options(${TARGET_NAME} PRIVATE -municode)
			set_target_properties(${TARGET_NAME} PROPERTIES LINK_FLAGS "-municode")
		endif()
	endif()
endfunction()

# Helper function to automatically set source groups for all source files
function(armips_target_sources TARGET SCOPE)
	target_sources("${TARGET}" "${SCOPE}" ${ARGN})
	source_group(TREE ${CMAKE_CURRENT_SOURCE_DIR} FILES ${ARGN})
endfunction()

# tinyformat
add_library(tinyformat INTERFACE)
target_include_directories(tinyformat INTERFACE ext/tinyformat)

# libarmips
add_library(armips STATIC)
init_target(armips)
target_link_libraries(armips PUBLIC tinyformat)

if (ARMIPS_USE_STD_FILESYSTEM)
	target_compile_definitions(armips PUBLIC ARMIPS_USE_STD_FILESYSTEM)
else()
	add_subdirectory(ext/filesystem)
	target_link_libraries(armips PUBLIC ghc_filesystem)
endif()

if (WIN32)
	target_link_libraries(armips PUBLIC shlwapi)
endif()

armips_target_sources(armips PRIVATE
	Archs/Architecture.h
	Archs/Architecture.cpp

	Archs/ARM/Arm.cpp
	Archs/ARM/Arm.h
	Archs/ARM/ArmExpressionFunctions.cpp
	Archs/ARM/ArmExpressionFunctions.h
	Archs/ARM/ArmElfRelocator.cpp
	Archs/ARM/ArmElfRelocator.h
	Archs/ARM/ArmOpcodes.cpp
	Archs/ARM/ArmOpcodes.h
	Archs/ARM/ArmParser.cpp
	Archs/ARM/ArmParser.h
	Archs/ARM/CArmInstruction.cpp
	Archs/ARM/CArmInstruction.h
	Archs/ARM/CThumbInstruction.cpp
	Archs/ARM/CThumbInstruction.h
	Archs/ARM/Pool.cpp
	Archs/ARM/Pool.h
	Archs/ARM/ThumbOpcodes.cpp
	Archs/ARM/ThumbOpcodes.h

	Archs/MIPS/CMipsInstruction.cpp
	Archs/MIPS/CMipsInstruction.h
	Archs/MIPS/Mips.cpp
	Archs/MIPS/Mips.h
	Archs/MIPS/MipsElfFile.cpp
	Archs/MIPS/MipsElfFile.h
	Archs/MIPS/MipsExpressionFunctions.cpp
	Archs/MIPS/MipsExpressionFunctions.h
	Archs/MIPS/MipsElfRelocator.cpp
	Archs/MIPS/MipsElfRelocator.h
	Archs/MIPS/MipsMacros.cpp
	Archs/MIPS/MipsMacros.h
	Archs/MIPS/MipsOpcodes.cpp
	Archs/MIPS/MipsOpcodes.h
	Archs/MIPS/MipsParser.cpp
	Archs/MIPS/MipsParser.h
	Archs/MIPS/PsxRelocator.cpp
	Archs/MIPS/PsxRelocator.h

	Archs/SuperH/SuperH.cpp
	Archs/SuperH/SuperH.h
	Archs/SuperH/CShInstruction.cpp
	Archs/SuperH/CShInstruction.h
	Archs/SuperH/ShParser.cpp
	Archs/SuperH/ShParser.h
	Archs/SuperH/ShOpcodes.cpp
	Archs/SuperH/ShOpcodes.h
	Archs/SuperH/ShElfRelocator.cpp
	Archs/SuperH/ShElfRelocator.h
	Archs/SuperH/ShExpressionFunctions.cpp
	Archs/SuperH/ShExpressionFunctions.h
	
	Commands/CAssemblerCommand.cpp
	Commands/CAssemblerCommand.h
	Commands/CAssemblerLabel.cpp
	Commands/CAssemblerLabel.h
	Commands/CDirectiveArea.cpp
	Commands/CDirectiveArea.h
	Commands/CDirectiveConditional.cpp
	Commands/CDirectiveConditional.h
	Commands/CDirectiveData.cpp
	Commands/CDirectiveData.h
	Commands/CDirectiveFile.cpp
	Commands/CDirectiveFile.h
	Commands/CDirectiveMessage.cpp
	Commands/CDirectiveMessage.h
	Commands/CommandSequence.cpp
	Commands/CommandSequence.h

	Core/ELF/ElfTypes.h
	Core/ELF/ElfRelocator.cpp
	Core/ELF/ElfRelocator.h
	Core/ELF/ElfFile.cpp
	Core/ELF/ElfFile.h
	Core/Allocations.cpp
	Core/Allocations.h
	Core/Assembler.cpp
	Core/Assembler.h
	Core/Common.cpp
	Core/Common.h
	Core/Expression.cpp
	Core/Expression.h
	Core/ExpressionFunctionHandler.cpp
	Core/ExpressionFunctionHandler.h
	Core/ExpressionFunctions.cpp
	Core/ExpressionFunctions.h
	Core/FileManager.cpp
	Core/FileManager.h
	Core/Misc.cpp
	Core/Misc.h
	Core/SymbolData.cpp
	Core/SymbolData.h
	Core/SymbolTable.cpp
	Core/SymbolTable.h
	Core/Types.cpp
	Core/Types.h

	Parser/DirectivesParser.cpp
	Parser/DirectivesParser.h
	Parser/ExpressionParser.cpp
	Parser/ExpressionParser.h
	Parser/Parser.cpp
	Parser/Parser.h
	Parser/Tokenizer.cpp
	Parser/Tokenizer.h
	
	Util/ByteArray.cpp
	Util/ByteArray.h
	Util/CRC.cpp
	Util/CRC.h
	Util/EncodingTable.cpp
	Util/EncodingTable.h
	Util/FileClasses.cpp
	Util/FileClasses.h
	Util/FileSystem.cpp
	Util/FileSystem.h
	Util/Util.cpp
	Util/Util.h
)

if (ARMIPS_PRECOMPILE_HEADERS)
	target_precompile_headers(armips PRIVATE
		[["Util/FileSystem.h"]]
		<tinyformat.h>
	)
	set_source_files_properties(Util/FileSystem.cpp PROPERTIES SKIP_PRECOMPILE_HEADERS ON)

	# Clang has an annoying bug when using precompiled headers where it outputs a reference to wmemchr when
	# __builtin_wmemchr is used. wmemchr is an inline function, which usually gets optimized away. The only
	# workaround seems to be to ensure that something generates a standalone wmemchr function... in other words,
	# referencing it and preventing it to be optimized away. See also: https://bugs.llvm.org/show_bug.cgi?id=41226
	if (CLANG AND MSVC)
		set(CLANG_WMEMCHR_PATH ${CMAKE_CURRENT_BINARY_DIR}/clang_wmemchr.cpp)
		file(GENERATE OUTPUT ${CLANG_WMEMCHR_PATH} CONTENT "#include <wchar.h>\nvoid armips_wmemchr_dummy() { wmemchr(L\"\", 0, 0); }")
		set_source_files_properties(${CLANG_WMEMCHR_PATH} PROPERTIES
			GENERATED TRUE
			SKIP_PRECOMPILE_HEADERS ON
			COMPILE_FLAGS "-Xclang -fno-inline-functions")
		target_sources(armips PRIVATE ${CLANG_WMEMCHR_PATH})
	endif()
endif()

if(NOT ARMIPS_LIBRARY_ONLY)
	# armips-bin
	add_executable(armips-bin "")
	init_target(armips-bin)
	set_target_properties(armips-bin PROPERTIES OUTPUT_NAME armips)
	target_link_libraries(armips-bin PRIVATE armips)

	armips_target_sources(armips-bin PRIVATE
		Main/CommandLineInterface.cpp
		Main/CommandLineInterface.h
		Main/main.cpp
		Main/Tests.cpp
		Main/Tests.h
	)

	# tests
	add_executable(armipstests "")
	init_target(armipstests)
	target_compile_definitions(armipstests PUBLIC ARMIPS_TESTS)
	target_link_libraries(armipstests PRIVATE armips)

	armips_target_sources(armipstests PRIVATE
		Main/CommandLineInterface.cpp
		Main/CommandLineInterface.h
		Main/main.cpp
		Main/Tests.cpp
		Main/Tests.h
	)

	enable_testing()
	add_test(NAME armipstests COMMAND armipstests ${CMAKE_CURRENT_SOURCE_DIR}/Tests)

	# install
	install(TARGETS armips-bin RUNTIME DESTINATION .)
	install(FILES Readme.md DESTINATION .)
endif()

=== ext/cpu_features/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

# option() honors normal variables.
# see: https://cmake.org/cmake/help/git-stage/policy/CMP0077.html
if(POLICY CMP0077)
  cmake_policy(SET CMP0077 NEW)
endif()

project(CpuFeatures VERSION 0.8.0 LANGUAGES C)

set(CMAKE_C_STANDARD 99)

# when cpu_features is included as subproject (i.e. using add_subdirectory(cpu_features))
# in the source tree of a project that uses it, test rules are disabled.
if(NOT CMAKE_SOURCE_DIR STREQUAL PROJECT_SOURCE_DIR)
  option(BUILD_TESTING "Enable test rule" OFF)
else()
  option(BUILD_TESTING "Enable test rule" ON)
endif()

# Default Build Type to be Release
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING
      "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
endif(NOT CMAKE_BUILD_TYPE)

# An option to enable/disable the executable target list_cpu_features.
# Disable it by default if the project is included as a subproject.
if(NOT CMAKE_SOURCE_DIR STREQUAL PROJECT_SOURCE_DIR)
  option(BUILD_EXECUTABLE "Build list_cpu_features executable." OFF)
else()
  option(BUILD_EXECUTABLE "Build list_cpu_features executable." ON)
endif()

# An option which allows to switch off install steps. Useful for embedding.
# Disable it by default if the project is included as a subproject.
if(NOT CMAKE_SOURCE_DIR STREQUAL PROJECT_SOURCE_DIR)
  option(ENABLE_INSTALL "Enable install targets" OFF)
else()
  option(ENABLE_INSTALL "Enable install targets" ON)
endif()

# BUILD_SHARED_LIBS is a standard CMake variable, but we declare it here to make
# it prominent in the GUI.
# cpu_features uses bit-fields which are - to some extends - implementation-defined (see https://en.cppreference.com/w/c/language/bit_field).
# As a consequence it is discouraged to use cpu_features as a shared library because different compilers may interpret the code in different ways.
# Prefer static linking from source whenever possible.
option(BUILD_SHARED_LIBS "Build library as shared." OFF)

# Force PIC on unix when building shared libs
# see: https://en.wikipedia.org/wiki/Position-independent_code
if(BUILD_SHARED_LIBS AND UNIX)
  option(CMAKE_POSITION_INDEPENDENT_CODE "Build with Position Independant Code." ON)
endif()

include(CheckIncludeFile)
include(CheckSymbolExists)
include(GNUInstallDirs)

macro(setup_include_and_definitions TARGET_NAME)
  target_include_directories(${TARGET_NAME}
    PUBLIC  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    PRIVATE $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/internal>
  )
  target_compile_definitions(${TARGET_NAME}
    PUBLIC STACK_LINE_READER_BUFFER_SIZE=1024
  )
endmacro()

set(PROCESSOR_IS_MIPS FALSE)
set(PROCESSOR_IS_ARM FALSE)
set(PROCESSOR_IS_AARCH64 FALSE)
set(PROCESSOR_IS_X86 FALSE)
set(PROCESSOR_IS_POWER FALSE)
set(PROCESSOR_IS_S390X FALSE)
set(PROCESSOR_IS_RISCV FALSE)
set(PROCESSOR_IS_LOONGARCH FALSE)

if(CMAKE_SYSTEM_PROCESSOR MATCHES "^mips")
  set(PROCESSOR_IS_MIPS TRUE)
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "(^aarch64)|(^arm64)|(^ARM64)")
  set(PROCESSOR_IS_AARCH64 TRUE)
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "^arm")
  set(PROCESSOR_IS_ARM TRUE)
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "(x86)|(x86_64)|(AMD64|amd64)|(^i.86$)")
  set(PROCESSOR_IS_X86 TRUE)
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "^(powerpc|ppc)")
  set(PROCESSOR_IS_POWER TRUE)
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "^(s390x)")
  set(PROCESSOR_IS_S390X TRUE)
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "^riscv")
  set(PROCESSOR_IS_RISCV TRUE)
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "^loongarch")
  set(PROCESSOR_IS_LOONGARCH TRUE)
endif()

macro(add_cpu_features_headers_and_sources HDRS_LIST_NAME SRCS_LIST_NAME)
  list(APPEND ${HDRS_LIST_NAME} ${PROJECT_SOURCE_DIR}/include/cpu_features_macros.h)
  list(APPEND ${HDRS_LIST_NAME} ${PROJECT_SOURCE_DIR}/include/cpu_features_cache_info.h)
  file(GLOB IMPL_SOURCES CONFIGURE_DEPENDS "${PROJECT_SOURCE_DIR}/src/impl_*.c")
  list(APPEND ${SRCS_LIST_NAME} ${IMPL_SOURCES})
  if(PROCESSOR_IS_MIPS)
      list(APPEND ${HDRS_LIST_NAME} ${PROJECT_SOURCE_DIR}/include/cpuinfo_mips.h)
  elseif(PROCESSOR_IS_ARM)
      list(APPEND ${HDRS_LIST_NAME} ${PROJECT_SOURCE_DIR}/include/cpuinfo_arm.h)
  elseif(PROCESSOR_IS_AARCH64)
      list(APPEND ${HDRS_LIST_NAME} ${PROJECT_SOURCE_DIR}/include/cpuinfo_aarch64.h)
      list(APPEND ${SRCS_LIST_NAME} ${PROJECT_SOURCE_DIR}/include/internal/windows_utils.h)
  elseif(PROCESSOR_IS_X86)
      list(APPEND ${HDRS_LIST_NAME} ${PROJECT_SOURCE_DIR}/include/cpuinfo_x86.h)
      list(APPEND ${SRCS_LIST_NAME} ${PROJECT_SOURCE_DIR}/include/internal/cpuid_x86.h)
      list(APPEND ${SRCS_LIST_NAME} ${PROJECT_SOURCE_DIR}/include/internal/windows_utils.h)
  elseif(PROCESSOR_IS_POWER)
      list(APPEND ${HDRS_LIST_NAME} ${PROJECT_SOURCE_DIR}/include/cpuinfo_ppc.h)
  elseif(PROCESSOR_IS_S390X)
      list(APPEND ${HDRS_LIST_NAME} ${PROJECT_SOURCE_DIR}/include/cpuinfo_s390x.h)
  elseif(PROCESSOR_IS_RISCV)
      list(APPEND ${HDRS_LIST_NAME} ${PROJECT_SOURCE_DIR}/include/cpuinfo_riscv.h)
  elseif(PROCESSOR_IS_LOONGARCH)
      list(APPEND ${HDRS_LIST_NAME} ${PROJECT_SOURCE_DIR}/include/cpuinfo_loongarch.h)
  else()
    message(FATAL_ERROR "Unsupported architectures ${CMAKE_SYSTEM_PROCESSOR}")
  endif()
endmacro()

#
# library : utils
#

add_library(utils OBJECT
  ${PROJECT_SOURCE_DIR}/include/internal/bit_utils.h
  ${PROJECT_SOURCE_DIR}/include/internal/filesystem.h
  ${PROJECT_SOURCE_DIR}/include/internal/stack_line_reader.h
  ${PROJECT_SOURCE_DIR}/include/internal/string_view.h
  ${PROJECT_SOURCE_DIR}/src/filesystem.c
  ${PROJECT_SOURCE_DIR}/src/stack_line_reader.c
  ${PROJECT_SOURCE_DIR}/src/string_view.c
)
setup_include_and_definitions(utils)

#
# library : unix_based_hardware_detection
#

if(UNIX)
  add_library(unix_based_hardware_detection OBJECT
    ${PROJECT_SOURCE_DIR}/include/internal/hwcaps.h
    ${PROJECT_SOURCE_DIR}/src/hwcaps.c
  )
  setup_include_and_definitions(unix_based_hardware_detection)
  check_include_file(dlfcn.h HAVE_DLFCN_H)
  if(HAVE_DLFCN_H)
    target_compile_definitions(unix_based_hardware_detection PRIVATE HAVE_DLFCN_H)
  endif()
  check_symbol_exists(getauxval "sys/auxv.h" HAVE_STRONG_GETAUXVAL)
  if(HAVE_STRONG_GETAUXVAL)
    target_compile_definitions(unix_based_hardware_detection PRIVATE HAVE_STRONG_GETAUXVAL)
  endif()
endif()

#
# library : cpu_features
#
set (CPU_FEATURES_HDRS)
set (CPU_FEATURES_SRCS)
add_cpu_features_headers_and_sources(CPU_FEATURES_HDRS CPU_FEATURES_SRCS)
list(APPEND CPU_FEATURES_SRCS $<TARGET_OBJECTS:utils>)
if(NOT PROCESSOR_IS_X86 AND UNIX)
  list(APPEND CPU_FEATURES_SRCS $<TARGET_OBJECTS:unix_based_hardware_detection>)
endif()
add_library(cpu_features ${CPU_FEATURES_HDRS} ${CPU_FEATURES_SRCS})
set_target_properties(cpu_features PROPERTIES PUBLIC_HEADER "${CPU_FEATURES_HDRS}")
setup_include_and_definitions(cpu_features)
target_link_libraries(cpu_features PUBLIC ${CMAKE_DL_LIBS})
target_include_directories(cpu_features
  PUBLIC $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/cpu_features>
)

if(APPLE)
  target_compile_definitions(cpu_features PRIVATE HAVE_SYSCTLBYNAME)
endif()
add_library(CpuFeature::cpu_features ALIAS cpu_features)

#
# program : list_cpu_features
#

if(BUILD_EXECUTABLE)
  add_executable(list_cpu_features ${PROJECT_SOURCE_DIR}/src/utils/list_cpu_features.c)
  target_link_libraries(list_cpu_features PRIVATE cpu_features)
  add_executable(CpuFeature::list_cpu_features ALIAS list_cpu_features)
endif()

#
# ndk_compat
#

if(ANDROID)
add_subdirectory(ndk_compat)
endif()

#
# tests
#

include(CTest)
if(BUILD_TESTING)
  # Automatically incorporate googletest into the CMake Project if target not
  # found.
  enable_language(CXX)

  set(CMAKE_CXX_STANDARD 14)
  set(CMAKE_CXX_STANDARD_REQUIRED ON)
  set(CMAKE_CXX_EXTENSIONS OFF) # prefer use of -std14 instead of -gnustd14

  if(NOT TARGET gtest OR NOT TARGET gmock_main)
    # Download and unpack googletest at configure time.
    configure_file(
      cmake/googletest.CMakeLists.txt.in
      googletest-download/CMakeLists.txt
    )

    execute_process(
      COMMAND ${CMAKE_COMMAND} -G "${CMAKE_GENERATOR}" .
      RESULT_VARIABLE result
      WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/googletest-download)

    if(result)
      message(FATAL_ERROR "CMake step for googletest failed: ${result}")
    endif()

    execute_process(
      COMMAND ${CMAKE_COMMAND} --build .
      RESULT_VARIABLE result
      WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/googletest-download)

    if(result)
      message(FATAL_ERROR "Build step for googletest failed: ${result}")
    endif()

    # Prevent overriding the parent project's compiler/linker settings on
    # Windows.
    set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)

    # Add googletest directly to our build. This defines the gtest and
    # gtest_main targets.
    add_subdirectory(${CMAKE_BINARY_DIR}/googletest-src
                     ${CMAKE_BINARY_DIR}/googletest-build
                     EXCLUDE_FROM_ALL)
  endif()

  add_subdirectory(test)
endif()

#
# Install cpu_features and list_cpu_features
#
if(ENABLE_INSTALL)
  include(GNUInstallDirs)
  install(TARGETS cpu_features
    EXPORT CpuFeaturesTargets
    PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/cpu_features
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    BUNDLE DESTINATION ${CMAKE_INSTALL_BINDIR}
  )
  if(BUILD_EXECUTABLE)
    install(TARGETS list_cpu_features
      EXPORT CpuFeaturesTargets
      PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/cpu_features
      ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
      LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
      RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
      BUNDLE DESTINATION ${CMAKE_INSTALL_BINDIR}
    )
  endif()
  install(EXPORT CpuFeaturesTargets
    NAMESPACE CpuFeatures::
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/CpuFeatures
    COMPONENT Devel
  )
  include(CMakePackageConfigHelpers)
  configure_package_config_file(cmake/CpuFeaturesConfig.cmake.in
    "${PROJECT_BINARY_DIR}/CpuFeaturesConfig.cmake"
    INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/CpuFeatures"
    NO_SET_AND_CHECK_MACRO
    NO_CHECK_REQUIRED_COMPONENTS_MACRO
  )
  write_basic_package_version_file(
    "${PROJECT_BINARY_DIR}/CpuFeaturesConfigVersion.cmake"
    COMPATIBILITY SameMajorVersion
  )
  install(
    FILES
      "${PROJECT_BINARY_DIR}/CpuFeaturesConfig.cmake"
      "${PROJECT_BINARY_DIR}/CpuFeaturesConfigVersion.cmake"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/CpuFeatures"
    COMPONENT Devel
  )
endif()

=== ext/glslang/CMakeLists.txt ===
# Copyright (C) 2020 The Khronos Group Inc.
#
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#    Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
#    Redistributions in binary form must reproduce the above
#    copyright notice, this list of conditions and the following
#    disclaimer in the documentation and/or other materials provided
#    with the distribution.
#
#    Neither the name of The Khronos Group Inc. nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
cmake_minimum_required(VERSION 3.14.0)
project(glslang)

set_property(GLOBAL PROPERTY USE_FOLDERS ON)

# Enable compile commands database
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# Adhere to GNU filesystem layout conventions
include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

# Needed for CMAKE_DEPENDENT_OPTION macro
include(CMakeDependentOption)

option(BUILD_SHARED_LIBS "Build Shared Libraries" OFF)
option(BUILD_EXTERNAL "Build external dependencies in /External" ON)

set(LIB_TYPE STATIC)

if(BUILD_SHARED_LIBS)
    set(LIB_TYPE SHARED)
endif()

if ("${CMAKE_BUILD_TYPE}" STREQUAL "")
    # This logic inside SPIRV-Tools, which can upset build target dependencies
    # if changed after targets are already defined. To prevent these issues,
    # ensure CMAKE_BUILD_TYPE is assigned early and at the glslang root scope.
    message(STATUS "No build type selected, default to Debug")
    set(CMAKE_BUILD_TYPE "Debug")
endif()

option(SKIP_GLSLANG_INSTALL "Skip installation" ${SKIP_GLSLANG_INSTALL})
if(NOT ${SKIP_GLSLANG_INSTALL})
  set(ENABLE_GLSLANG_INSTALL ON)
endif()
option(ENABLE_SPVREMAPPER "Enables building of SPVRemapper" ON)

option(ENABLE_GLSLANG_BINARIES "Builds glslangValidator and spirv-remap" ON)

option(ENABLE_GLSLANG_JS
    "If using Emscripten, build glslang.js. Otherwise, builds a sample executable for binary-size testing." OFF)
CMAKE_DEPENDENT_OPTION(ENABLE_GLSLANG_WEBMIN
    "Reduces glslang to minimum needed for web use"
    OFF "ENABLE_GLSLANG_JS"
    OFF)
CMAKE_DEPENDENT_OPTION(ENABLE_GLSLANG_WEBMIN_DEVEL
    "For ENABLE_GLSLANG_WEBMIN builds, enables compilation error messages"
    OFF "ENABLE_GLSLANG_WEBMIN"
    OFF)
CMAKE_DEPENDENT_OPTION(ENABLE_EMSCRIPTEN_SINGLE_FILE
    "If using Emscripten, enables SINGLE_FILE build"
    OFF "ENABLE_GLSLANG_JS AND EMSCRIPTEN"
    OFF)
CMAKE_DEPENDENT_OPTION(ENABLE_EMSCRIPTEN_ENVIRONMENT_NODE
    "If using Emscripten, builds to run on Node instead of Web"
    OFF "ENABLE_GLSLANG_JS AND EMSCRIPTEN"
    OFF)

CMAKE_DEPENDENT_OPTION(ENABLE_HLSL
    "Enables HLSL input support"
    ON "NOT ENABLE_GLSLANG_WEBMIN"
    OFF)

option(ENABLE_RTTI "Enables RTTI" OFF)
option(ENABLE_EXCEPTIONS "Enables Exceptions" OFF)
option(ENABLE_OPT "Enables spirv-opt capability if present" ON)

if(MINGW OR (CMAKE_SYSTEM_NAME STREQUAL "Darwin" AND ${CMAKE_CXX_COMPILER_ID} MATCHES "GNU"))
    # Workaround for CMake behavior on Mac OS with gcc, cmake generates -Xarch_* arguments
    # which gcc rejects
    option(ENABLE_PCH "Enables Precompiled header" OFF)
else()
    option(ENABLE_PCH "Enables Precompiled header" ON)
endif()
option(ENABLE_CTEST "Enables testing" ON)

if(ENABLE_GLSLANG_INSTALL AND CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT AND WIN32)
    set(CMAKE_INSTALL_PREFIX "install" CACHE STRING "..." FORCE)
endif()

option(USE_CCACHE "Use ccache" OFF)
if(USE_CCACHE)
    find_program(CCACHE_FOUND ccache)
    if(CCACHE_FOUND)
        set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
    endif()
endif()

if(ENABLE_CTEST)
    include(CTest)
endif()

if(ENABLE_HLSL)
    add_definitions(-DENABLE_HLSL)
endif()

if(ENABLE_GLSLANG_WEBMIN)
    add_definitions(-DGLSLANG_WEB)
    if(ENABLE_GLSLANG_WEBMIN_DEVEL)
        add_definitions(-DGLSLANG_WEB_DEVEL)
    endif()
endif()

if(WIN32)
    set(CMAKE_DEBUG_POSTFIX "d")
    option(OVERRIDE_MSVCCRT "Overrides runtime of MSVC " ON)
    if(MSVC AND OVERRIDE_MSVCCRT)
        include(ChooseMSVCCRT.cmake)
    endif()
    add_definitions(-DGLSLANG_OSINCLUDE_WIN32)
elseif(UNIX)
    add_definitions(-DGLSLANG_OSINCLUDE_UNIX)
else()
    message("unknown platform")
endif()

if(${CMAKE_CXX_COMPILER_ID} MATCHES "GNU")
    add_compile_options(-Wall -Wmaybe-uninitialized -Wuninitialized -Wunused -Wunused-local-typedefs
                        -Wunused-parameter -Wunused-value  -Wunused-variable -Wunused-but-set-parameter -Wunused-but-set-variable -fno-exceptions)
    add_compile_options(-Wno-reorder)  # disable this from -Wall, since it happens all over.
    if(NOT ENABLE_RTTI)
        add_compile_options(-fno-rtti)
    endif()
    if(NOT ENABLE_EXCEPTIONS)
        add_compile_options(-fno-exceptions)
    endif()
    if(NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS "9.0.0")
        add_compile_options(-Werror=deprecated-copy)
    endif()

    if(NOT CMAKE_VERSION VERSION_LESS "3.13" AND NOT CMAKE_SYSTEM_NAME STREQUAL "Darwin")
        # Error if there's symbols that are not found at link time.
        # add_link_options() was added in CMake 3.13 - if using an earlier
        # version don't set this - it should be caught by presubmits anyway.
        add_link_options("-Wl,--no-undefined")
    endif()
elseif(${CMAKE_CXX_COMPILER_ID} MATCHES "Clang" AND NOT MSVC)
    add_compile_options(-Wall -Wuninitialized -Wunused -Wunused-local-typedefs
                        -Wunused-parameter -Wunused-value  -Wunused-variable)
    add_compile_options(-Wno-reorder)  # disable this from -Wall, since it happens all over.
    if(NOT ENABLE_RTTI)
        add_compile_options(-fno-rtti)
    endif()
    if(NOT ENABLE_EXCEPTIONS)
        add_compile_options(-fno-exceptions)
    endif()

    if(NOT CMAKE_VERSION VERSION_LESS "3.13")
        # Error if there's symbols that are not found at link time.
        # add_link_options() was added in CMake 3.13 - if using an earlier
        # version don't set this - it should be caught by presubmits anyway.
        if (CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")
            add_link_options("-Wl,-undefined,error")
        else()
            add_link_options("-Wl,--no-undefined")
        endif()
    endif()
elseif(MSVC)
    if(NOT ENABLE_RTTI)
        string(FIND "${CMAKE_CXX_FLAGS}" "/GR" MSVC_HAS_GR)
        if(MSVC_HAS_GR)
            string(REGEX REPLACE "/GR" "/GR-" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
        else()
            add_compile_options(/GR-) # Disable RTTI
        endif()
    endif()
    if(ENABLE_EXCEPTIONS)
        add_compile_options(/EHsc) # Enable Exceptions
	else()
        string(REGEX REPLACE "/EHsc" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}") # Try to remove default /EHsc cxx_flag
        add_compile_options(/D_HAS_EXCEPTIONS=0)
    endif()
endif()

if(ENABLE_GLSLANG_JS)
    if(MSVC)
        add_compile_options(/Os /GR-)
    else()
        add_compile_options(-Os -fno-rtti -fno-exceptions)
        if(${CMAKE_CXX_COMPILER_ID} MATCHES "Clang" AND NOT MSVC)
            add_compile_options(-Wno-unused-parameter)
            add_compile_options(-Wno-unused-variable -Wno-unused-const-variable)
        endif()
    endif()
endif()

# Request C++17
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

function(glslang_set_link_args TARGET)
    # For MinGW compiles, statically link against the GCC and C++ runtimes.
    # This avoids the need to ship those runtimes as DLLs.
    if(WIN32 AND ${CMAKE_CXX_COMPILER_ID} MATCHES "GNU")
        set_target_properties(${TARGET} PROPERTIES
                              LINK_FLAGS "-static -static-libgcc -static-libstdc++")
    endif()
endfunction(glslang_set_link_args)

if(NOT COMMAND find_host_package)
    macro(find_host_package)
        find_package(${ARGN})
    endmacro()
endif()

# Root directory for build-time generated include files
set(GLSLANG_GENERATED_INCLUDEDIR "${CMAKE_BINARY_DIR}/include")

################################################################################
# Build version information generation
################################################################################
include(parse_version.cmake)
set(GLSLANG_CHANGES_FILE      "${CMAKE_CURRENT_SOURCE_DIR}/CHANGES.md")
set(GLSLANG_BUILD_INFO_H_TMPL "${CMAKE_CURRENT_SOURCE_DIR}/build_info.h.tmpl")
set(GLSLANG_BUILD_INFO_H      "${GLSLANG_GENERATED_INCLUDEDIR}/glslang/build_info.h")

parse_version(${GLSLANG_CHANGES_FILE} GLSLANG)

function(configurate_version)
    set(major ${GLSLANG_VERSION_MAJOR})
    set(minor ${GLSLANG_VERSION_MINOR})
    set(patch ${GLSLANG_VERSION_PATCH})
    set(flavor ${GLSLANG_VERSION_FLAVOR})
    configure_file(${GLSLANG_BUILD_INFO_H_TMPL} ${GLSLANG_BUILD_INFO_H} @ONLY)
endfunction()

configurate_version()

# glslang_add_build_info_dependency() adds the glslang-build-info dependency and
# generated include directories to target.
function(glslang_add_build_info_dependency target)
    target_include_directories(${target} PUBLIC $<BUILD_INTERFACE:${GLSLANG_GENERATED_INCLUDEDIR}>)
endfunction()

# glslang_only_export_explicit_symbols() makes the symbol visibility hidden by
# default for <target> when building shared libraries, and sets the
# GLSLANG_IS_SHARED_LIBRARY define, and GLSLANG_EXPORTING to 1 when specifically
# building <target>.
function(glslang_only_export_explicit_symbols target)
    if(BUILD_SHARED_LIBS)
        target_compile_definitions(${target} PUBLIC "GLSLANG_IS_SHARED_LIBRARY=1")
        if(WIN32)
            target_compile_definitions(${target} PRIVATE "GLSLANG_EXPORTING=1")
        else()
            target_compile_options(${target} PRIVATE "-fvisibility=hidden")
        endif()
    endif()
endfunction()

# glslang_pch() adds precompiled header rules to <target> for the pre-compiled
# header file <pch>. As target_precompile_headers() was added in CMake 3.16,
# this is a no-op if called on earlier versions of CMake.
if(NOT CMAKE_VERSION VERSION_LESS "3.16" AND ENABLE_PCH)
    function(glslang_pch target pch)
        target_precompile_headers(${target} PRIVATE ${pch})
    endfunction()
else()
    function(glslang_pch target pch)
    endfunction()
    if(ENABLE_PCH)
        message("Your CMake version is ${CMAKE_VERSION}. Update to at least 3.16 to enable precompiled headers to speed up incremental builds")
    endif()
endif()

if(BUILD_EXTERNAL AND IS_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/External)
    find_host_package(PythonInterp 3 REQUIRED)

    # We depend on these for later projects, so they should come first.
    add_subdirectory(External)
endif()

if(NOT TARGET SPIRV-Tools-opt)
    set(ENABLE_OPT OFF)
endif()

if(ENABLE_OPT)
    message(STATUS "optimizer enabled")
    add_definitions(-DENABLE_OPT=1)
else()
    if(ENABLE_HLSL)
        message(STATUS "spirv-tools not linked - illegal SPIRV may be generated for HLSL")
    endif()
    add_definitions(-DENABLE_OPT=0)
endif()

add_subdirectory(glslang)
add_subdirectory(OGLCompilersDLL)
if(ENABLE_GLSLANG_BINARIES)
    add_subdirectory(StandAlone)
endif()
add_subdirectory(SPIRV)

=== ext/libadrenotools/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)

if(NOT ${CMAKE_ANDROID_ARCH_ABI} STREQUAL arm64-v8a)
	message(FATAL_ERROR "Unsupported target architecture: ${CMAKE_ANDROID_ARCH_ABI}. Please make an issue on the repo!")
endif()

project(adrenotools LANGUAGES CXX C)

set(GEN_INSTALL_TARGET OFF CACHE BOOL "")

add_subdirectory(lib/linkernsbypass)

set(LIB_SOURCES src/bcenabler.cpp
                src/driver.cpp
                include/adrenotools/bcenabler.h
                include/adrenotools/driver.h
                include/adrenotools/priv.h)

add_library(adrenotools ${LIB_SOURCES})

target_include_directories(adrenotools PUBLIC include)
target_include_directories(adrenotools PRIVATE .)
target_compile_options(adrenotools PRIVATE -Wall -Wextra)
target_link_libraries(adrenotools android linkernsbypass)

add_subdirectory(src/hook)
if (${BUILD_SHARED_LIBS})
    target_link_options(adrenotools PRIVATE "-Wl,-s,--exclude-libs,liblinkernsbypass.a")
endif()
if (${GEN_INSTALL_TARGET})
  configure_file(adrenotools.pc.in adrenotools.pc @ONLY)
  install(FILES ${CMAKE_BINARY_DIR}/adrenotools.pc DESTINATION lib/pkgconfig)
  install(TARGETS adrenotools main_hook file_redirect_hook gsl_alloc_hook hook_impl)
  install(DIRECTORY include/
          DESTINATION include
          FILES_MATCHING PATTERN "*.h*")
endif()

=== ext/libchdr-build/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.10.0)
project (chdr)

set(LZMA_DIR ../libchdr/deps/lzma-22.01/src)
set(SRC_DIR ../libchdr/src)

include_directories(../libchdr/deps/lzma-22.01/include)
include_directories(../libchdr/include)
include_directories(../zlib)
include_directories(../zstd/lib)

add_definitions(-D_7ZIP_ST)

# Hack - CpuArch.c has a workaround that we reuse.
add_definitions(-D__SWITCH__)

set(ALL_SOURCE_FILES
	${LZMA_DIR}/Alloc.c
	${LZMA_DIR}/Bcj2.c
	${LZMA_DIR}/Bcj2Enc.c
	${LZMA_DIR}/Bra.c
	${LZMA_DIR}/Bra86.c
	${LZMA_DIR}/CpuArch.c
	${LZMA_DIR}/Delta.c
	${LZMA_DIR}/LzFind.c
	${LZMA_DIR}/LzFindOpt.c
	${LZMA_DIR}/LzmaDec.c
	${LZMA_DIR}/LzmaEnc.c
	${LZMA_DIR}/Lzma86Dec.c
	${LZMA_DIR}/Lzma86Enc.c
	${LZMA_DIR}/LzmaLib.c
	${LZMA_DIR}/Sort.c
	${SRC_DIR}/libchdr_bitstream.c
	${SRC_DIR}/libchdr_cdrom.c
	${SRC_DIR}/libchdr_chd.c
	${SRC_DIR}/libchdr_flac.c
	${SRC_DIR}/libchdr_huffman.c
	)

add_library(chdr STATIC ${ALL_SOURCE_FILES})

=== ext/libchdr/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.9)

project(chdr VERSION 0.2 LANGUAGES C)

if(CMAKE_PROJECT_NAME STREQUAL "chdr")
  option(BUILD_SHARED_LIBS "Build libchdr also as a shared library" ON)
endif()
option(INSTALL_STATIC_LIBS "Install static libraries" OFF)
option(WITH_SYSTEM_ZLIB "Use system provided zlib library" OFF)

option(BUILD_LTO "Compile libchdr with link-time optimization if supported" OFF)
if(BUILD_LTO)
  include(CheckIPOSupported)
  check_ipo_supported(RESULT HAVE_IPO)
  if(HAVE_IPO)
    set(CMAKE_INTERPROCEDURAL_OPTIMIZATION TRUE)
  endif()
endif()

include(GNUInstallDirs)

#--------------------------------------------------
# dependencies
#--------------------------------------------------


# lzma
add_subdirectory(deps/lzma-22.01 EXCLUDE_FROM_ALL)
  list(APPEND CHDR_LIBS lzma)
  list(APPEND CHDR_INCLUDES lzma)

# zlib
if (WITH_SYSTEM_ZLIB)
  find_package(ZLIB REQUIRED)
  list(APPEND PLATFORM_LIBS ZLIB::ZLIB)
else()
  add_subdirectory(deps/zlib-1.2.13 EXCLUDE_FROM_ALL)
  set_target_properties(zlibstatic PROPERTIES POSITION_INDEPENDENT_CODE ON)
  list(APPEND CHDR_LIBS zlibstatic)
  list(APPEND CHDR_INCLUDES "${CMAKE_CURRENT_SOURCE_DIR}/deps/zlib-1.2.13" "${CMAKE_CURRENT_BINARY_DIR}/deps/zlib-1.2.13")
endif()

# zstd 
add_subdirectory(deps/zstd-1.5.5 EXCLUDE_FROM_ALL)
list(APPEND CHDR_LIBS zstd)
list(APPEND CHDR_INCLUDES zstd)
#--------------------------------------------------
# chdr
#--------------------------------------------------

set(CHDR_SOURCES
  src/libchdr_bitstream.c
  src/libchdr_cdrom.c
  src/libchdr_chd.c
  src/libchdr_flac.c
  src/libchdr_huffman.c
)

list(APPEND CHDR_INCLUDES ${CMAKE_CURRENT_BINARY_DIR}/include)

add_library(chdr-static STATIC ${CHDR_SOURCES})
target_include_directories(chdr-static PRIVATE ${CHDR_INCLUDES} PUBLIC include)
target_link_libraries(chdr-static PRIVATE ${CHDR_LIBS} ${PLATFORM_LIBS})

if(MSVC)
  target_compile_definitions(chdr-static PRIVATE _CRT_SECURE_NO_WARNINGS)
endif()

if (INSTALL_STATIC_LIBS)
  install(TARGETS chdr-static ${CHDR_LIBS}
    ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
  )
endif()

if (BUILD_SHARED_LIBS)
  add_library(chdr SHARED ${CHDR_SOURCES})
  target_include_directories(chdr PRIVATE ${CHDR_INCLUDES} PUBLIC include)
  target_link_libraries(chdr PRIVATE ${CHDR_LIBS} ${PLATFORM_LIBS})

  if(MSVC)
    target_compile_definitions(chdr PUBLIC "CHD_DLL")
    target_compile_definitions(chdr PRIVATE "CHD_DLL_EXPORTS")
    target_compile_definitions(chdr PRIVATE _CRT_SECURE_NO_WARNINGS)
  elseif(APPLE)
    target_link_libraries(chdr PRIVATE -Wl,-dead_strip -Wl,-exported_symbol,_chd_*)
  else()
    target_link_libraries(chdr PRIVATE -Wl,--version-script ${CMAKE_CURRENT_SOURCE_DIR}/src/link.T -Wl,--no-undefined)
  endif()

  set_target_properties(chdr PROPERTIES C_VISIBILITY_PRESET hidden)
  set_target_properties(chdr PROPERTIES VISIBILITY_INLINES_HIDDEN 1)
  set_target_properties(chdr PROPERTIES PUBLIC_HEADER "include/libchdr/bitstream.h;include/libchdr/cdrom.h;include/libchdr/chd.h;include/libchdr/chdconfig.h;include/libchdr/coretypes.h;include/libchdr/flac.h;include/libchdr/huffman.h")
  set_target_properties(chdr PROPERTIES VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}" SOVERSION ${PROJECT_VERSION_MAJOR})

  if (CMAKE_BUILD_TYPE MATCHES Release)
    #add_custom_command(TARGET chdr POST_BUILD COMMAND ${CMAKE_STRIP} libchdr.so)
  endif (CMAKE_BUILD_TYPE MATCHES Release)

  install(TARGETS chdr
    LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/libchdr"
  )

  configure_file(pkg-config.pc.in ${CMAKE_BINARY_DIR}/libchdr.pc @ONLY)
  install(FILES ${CMAKE_BINARY_DIR}/libchdr.pc DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")
endif()

add_subdirectory(tests)

=== ext/libkirk/CMakeLists.txt ===
set(SRCS
    AES.c
    bn.c
    ec.c
    kirk_engine.c
    SHA1.c
)

set(SRCS ${SRCS})

add_library(kirk STATIC ${SRCS})

if(UNIX)
  add_definitions(-fPIC)
endif(UNIX)

=== ext/libpng17/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8)
project(libpng17)

add_library(png17 STATIC
	pngconf.h
	pngdebug.h
	png.c
	png.h
	pngerror.c
	pngget.c
	pnginfo.h
	pnglibconf.h
	pngmem.c
	pngpread.c
	pngpriv.h
	pngread.c
	pngrio.c
	pngrtran.c
	pngrutil.c
	pngset.c
	pngstruct.h
	pngtest.c
	pngtrans.c
	pngwio.c
	pngwrite.c
	pngwtran.c
	pngwutil.c
)

# Add arm files for ARM processors
if("${CMAKE_SYSTEM_PROCESSOR}" MATCHES "arm(64)?|aarch64")
	set (ARM_FILES arm/arm_init.c
	)

	# Check if it's 32 bit
	if("${CMAKE_SIZEOF_VOID_P}" EQUAL 4)
		list(APPEND ARM_FILES arm/filter_neon.S)
	else()
		list(APPEND ARM_FILES arm/filter_neon_intrinsics.c)
	endif()

	target_sources(png17 PRIVATE ${ARM_FILES})
endif()

=== ext/libzip/CMakeLists.txt ===
set(SRCS
  zip_add.c
  zip_add_dir.c
  zip_add_entry.c
  zip_algorithm_deflate.c
  zip_buffer.c
  zip_close.c
  zip_delete.c
  zip_dir_add.c
  zip_dirent.c
  zip_discard.c
  zip_entry.c
  zip_error.c
  zip_error_clear.c
  zip_error_get.c
  zip_error_get_sys_type.c
  zip_error_strerror.c
  zip_error_to_str.c
  zip_extra_field.c
  zip_extra_field_api.c
  zip_fclose.c
  zip_fdopen.c
  zip_file_add.c
  zip_file_error_clear.c
  zip_file_error_get.c
  zip_file_get_comment.c
  zip_file_get_external_attributes.c
  zip_file_get_offset.c
  zip_file_rename.c
  zip_file_replace.c
  zip_file_set_comment.c
  zip_file_set_encryption.c
  zip_file_set_external_attributes.c
  zip_file_set_mtime.c
  zip_file_strerror.c
  zip_fopen.c
  zip_fopen_encrypted.c
  zip_fopen_index.c
  zip_fopen_index_encrypted.c
  zip_fread.c
  zip_fseek.c
  zip_ftell.c
  zip_get_archive_comment.c
  zip_get_archive_flag.c
  zip_get_encryption_implementation.c
  zip_get_file_comment.c
  zip_get_name.c
  zip_get_num_entries.c
  zip_get_num_files.c
  zip_hash.c
  zip_io_util.c
  zip_libzip_version.c
  zip_memdup.c
  zip_name_locate.c
  zip_new.c
  zip_open.c
  zip_pkware.c
  zip_progress.c
  zip_rename.c
  zip_replace.c
  zip_set_archive_comment.c
  zip_set_archive_flag.c
  zip_set_default_password.c
  zip_set_file_comment.c
  zip_set_file_compression.c
  zip_set_name.c
  zip_source_accept_empty.c
  zip_source_begin_write.c
  zip_source_begin_write_cloning.c
  zip_source_buffer.c
  zip_source_call.c
  zip_source_close.c
  zip_source_commit_write.c
  zip_source_compress.c
  zip_source_crc.c
  zip_source_error.c
  zip_source_file_common.c
  zip_source_file_stdio.c
  zip_source_free.c
  zip_source_function.c
  zip_source_get_file_attributes.c
  zip_source_is_deleted.c
  zip_source_layered.c
  zip_source_open.c
  zip_source_pkware_decode.c
  zip_source_pkware_encode.c
  zip_source_read.c
  zip_source_remove.c
  zip_source_rollback_write.c
  zip_source_seek.c
  zip_source_seek_write.c
  zip_source_stat.c
  zip_source_supports.c
  zip_source_tell.c
  zip_source_tell_write.c
  zip_source_window.c
  zip_source_write.c
  zip_source_zip.c
  zip_source_zip_new.c
  zip_stat.c
  zip_stat_index.c
  zip_stat_init.c
  zip_strerror.c
  zip_string.c
  zip_unchange.c
  zip_unchange_all.c
  zip_unchange_archive.c
  zip_unchange_data.c
  zip_utf-8.c
  zip_err_str.c)

if(WIN32)
  set(SRCS ${SRCS}
    zip_source_file_win32.c
    zip_source_file_win32_named.c
    zip_source_file_win32_utf16.c
    zip_source_file_win32_utf8.c)
  if(CMAKE_SYSTEM_NAME MATCHES WindowsPhone OR CMAKE_SYSTEM_NAME MATCHES WindowsStore)
    set(SRCS ${SRCS} zip_random_uwp.c)
  else()
    set(SRCS ${SRCS} zip_source_file_win32_ansi.c zip_random_win32.c)
  endif()
else()
  set(SRCS ${SRCS}
    zip_mkstempm.c
    zip_source_file_stdio_named.c
	zip_random_unix.c)
endif()

add_library(zip STATIC ${SRCS})

if(UNIX)
  add_definitions(-fPIC)
endif(UNIX)

=== debian/changelog ===
ppsspp (1.19.3-0deepin1) unstable; urgency=medium

  * Downgrade to 1.19.3-0deepin1 for deepin versioning.
  * remove support mips64

 -- lhdjply <lhdjply@126.com>  Mon, 18 Aug 2025 14:57:03 +0800

ppsspp (1.19.3-1deepin1) unstable; urgency=medium

  * support loongarch64 riscv64 mips64
  * sdl set default version
  * remove qt version
  * remove libretro

 -- lhdjply <lhdjply@126.com>  Mon, 11 Aug 2025 11:08:03 +0800

ppsspp (1.19.3-1~25.04~ppa1) plucky; urgency=medium

  * New upstream release
  * debian/patches/ffmpeg_disable-inline-asm.patch: disable inline asm optimization

 -- Xu Zhen <xuzhen@fastmail.com>  Mon, 14 Jul 2025 19:33:23 +0800

ppsspp (1.19.2-1~25.04~ppa1) plucky; urgency=medium

  * New upstream release
  * debian/patches/ffmpeg_disable-inline-asm.patch: disable inline asm optimization

 -- Xu Zhen <xuzhen@fastmail.com>  Mon, 16 Jun 2025 20:12:38 +0800

ppsspp (1.19.1-1~25.04~ppa1) plucky; urgency=medium

  * New upstream release
  * debian/patches/ffmpeg_disable-inline-asm.patch: disable inline asm optimization

 -- Xu Zhen <xuzhen@fastmail.com>  Tue, 10 Jun 2025 21:26:19 +0800

ppsspp (1.19.0-1~25.04~ppa2) plucky; urgency=medium

  * debian/patches/android.patch: add missing android files

 -- Xu Zhen <xuzhen@fastmail.com>  Fri, 06 Jun 2025 22:57:20 +0800

ppsspp (1.19.0-1~25.04~ppa1) plucky; urgency=medium

  * New upstream release
  * debian/patches/ffmpeg_disable-inline-asm.patch: disable inline asm optimization

 -- Xu Zhen <xuzhen@fastmail.com>  Fri, 06 Jun 2025 21:23:13 +0800

ppsspp (1.18.1-1~25.04~ppa1) plucky; urgency=medium

  * Build for 25.04

 -- Xu Zhen <xuzhen@fastmail.com>  Sat, 21 Dec 2024 22:49:16 +0800

ppsspp (1.18.1-1~24.10~ppa1) oracular; urgency=medium

  * New upstream release
  * debian/patches/miniupnpc.patch: Fix FTBFS
  * debian/patches/ffmpeg_disable-inline-asm.patch: disable inline asm optimization

 -- Xu Zhen <xuzhen@fastmail.com>  Tue, 05 Nov 2024 19:28:30 +0800

ppsspp (1.18.0-1~24.10~ppa1) oracular; urgency=medium

  * New upstream release
  * debian/patches/miniupnpc.patch: Fix FTBFS
  * debian/patches/ffmpeg_disable-inline-asm.patch: disable inline asm optimization

 -- Xu Zhen <xuzhen@fastmail.com>  Mon, 04 Nov 2024 21:01:20 +0800

ppsspp (1.17.1-1~ppa4~24.10) oracular; urgency=medium

  * debian/patches/miniupnp.patch: Fix FTBFS

 -- Xu Zhen <xuzhen@fastmail.com>  Sun, 03 Nov 2024 11:43:37 +0800

ppsspp (1.17.1-1~ppa3~24.10) oracular; urgency=medium

  * Rebuild against libminiupnpc18

 -- Xu Zhen <xuzhen@fastmail.com>  Sat, 02 Nov 2024 10:04:25 +0800

ppsspp (1.17.1-1~ppa2~24.10) oracular; urgency=medium

  * Build for 24.10

 -- Xu Zhen <xuzhen@fastmail.com>  Mon, 24 Jun 2024 20:17:34 +0800

ppsspp (1.17.1-1~ppa2~24.04) noble; urgency=medium

  * Rebuild against t64 libraries

 -- Xu Zhen <xuzhen@fastmail.com>  Fri, 29 Mar 2024 20:19:43 +0800

ppsspp (1.17.1-1~ppa1~24.04) noble; urgency=medium

  * New upstream release
  * debian/patches/ffmpeg_disable-inline-asm.patch: disable inline asm optimization

 -- Xu Zhen <xuzhen@fastmail.com>  Sun, 04 Feb 2024 22:00:14 +0800

ppsspp (1.17.0-1~ppa1~24.04) noble; urgency=medium

  * New upstream release
  * debian/patches/ffmpeg_disable-inline-asm.patch: disable inline asm optimization

 -- Xu Zhen <xuzhen@fastmail.com>  Sun, 28 Jan 2024 12:22:26 +0800

ppsspp (1.16.6-1~ppa3~23.10) mantic; urgency=medium

  * Build without libsdl2-ttf

 -- Xu Zhen <xuzhen@fastmail.com>  Sat, 14 Oct 2023 01:31:25 +0800

ppsspp (1.16.6-1~ppa2~23.10) mantic; urgency=medium

  * debian/rules: various changes

 -- Xu Zhen <xuzhen@fastmail.com>  Sat, 14 Oct 2023 01:01:41 +0800

ppsspp (1.16.6-1~ppa1~23.10) mantic; urgency=medium

  * New upstream release
  * debian/patches/use_glvnd.patch: prefer GLVND libraries
  * debian/patches/ffmpeg_disable-inline-asm.patch: disable inline asm optimization

 -- Xu Zhen <xuzhen@fastmail.com>  Fri, 13 Oct 2023 20:59:11 +0800

ppsspp (1.16.5-1~ppa1~23.10) mantic; urgency=medium

  * New upstream release
  * debian/patches/use_glvnd.patch: prefer GLVND libraries
  * debian/patches/ffmpeg_disable-inline-asm.patch: disable inline asm optimization

 -- Xu Zhen <xuzhen@fastmail.com>  Thu, 28 Sep 2023 20:27:59 +0800

ppsspp (1.16.4-1~ppa1~23.10) mantic; urgency=medium

  * New upstream release
  * debian/patches/use_glvnd.patch: prefer GLVND libraries
  * debian/patches/ffmpeg_disable-inline-asm.patch: disable inline asm optimization

 -- Xu Zhen <xuzhen@fastmail.com>  Mon, 25 Sep 2023 22:11:20 +0800

ppsspp (1.16.3-1~ppa1~23.10) mantic; urgency=medium

  * New upstream release
  * debian/patches/use_glvnd.patch: prefer GLVND libraries
  * debian/patches/ffmpeg_disable-inline-asm.patch: disable inline asm optimization

 -- Xu Zhen <xuzhen@fastmail.com>  Sat, 23 Sep 2023 15:03:43 +0800

ppsspp (1.16.2-1~ppa1~23.10) mantic; urgency=medium

  * New upstream release
  * debian/patches/use_glvnd.patch: prefer GLVND libraries
  * debian/patches/ffmpeg_disable-inline-asm.patch: disable inline asm optimization

 -- Xu Zhen <xuzhen@fastmail.com>  Tue, 19 Sep 2023 20:00:35 +0800

ppsspp (1.16.1-1~ppa1~23.10) mantic; urgency=medium

  * New upstream release
  * debian/patches/use_glvnd.patch: prefer GLVND libraries
  * debian/patches/ffmpeg_disable-inline-asm.patch: disable inline asm optimization

 -- Xu Zhen <xuzhen@fastmail.com>  Wed, 13 Sep 2023 22:34:41 +0800

ppsspp (1.16.0-1~ppa2~23.10) mantic; urgency=medium

  * debian/patches/fixtype.patch: Fix FTBFS
  * Build ppsspp_libretro.so

 -- Xu Zhen <xuzhen@fastmail.com>  Sun, 10 Sep 2023 20:55:53 +0800

ppsspp (1.16.0-1~ppa1~23.10) mantic; urgency=medium

  * New upstream release
  * debian/patches/use_glvnd.patch: prefer GLVND libraries
  * debian/patches/ffmpeg_disable-inline-asm.patch: disable inline asm optimization

 -- Xu Zhen <xuzhen@fastmail.com>  Sun, 10 Sep 2023 13:52:10 +0800

ppsspp (1.15.4-1~ppa1~23.04) lunar; urgency=medium

  * New upstream release
  * debian/patches/use_glvnd.patch: prefer GLVND libraries


=== debian/control ===
Source: ppsspp
Section: games
Priority: optional
Maintainer: Xu Zhen <xuzhen@fastmail.com>
Build-Depends: debhelper (>= 12),
               dh-exec,
#              clang [armhf],
               cmake (>= 3.16),
               libgl-dev, 
               libglew-dev,
               libminiupnpc-dev,
               libpng-dev (>= 1.6) [i386 amd64],
               libsdl2-dev,
               libsnappy-dev,
               libvulkan-dev,
               libwayland-dev,
               libzip-dev,
               libzstd-dev,
               python3,
               zlib1g-dev
Standards-Version: 4.0.0
Homepage: http://www.ppsspp.org

Package: ppsspp
Architecture: any
Depends: ppsspp-common (= ${source:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Sony PSP emulator - SDL version
 PPSSPP can run your PSP games on your PC in full HD resolution. It can even 
 upscale textures that would otherwise be too blurry as they were made for 
 the small screen of the original PSP.
 .
 All trademarks are property of their respective owners. The emulator is for 
 educational and development purposes only and it may not be used to play games
 you do not legally own.
 .
 This package provides the SDL port which relies in less dependencies,
 such as Qt libraries.

Package: ppsspp-common
Architecture: all
Depends: ${misc:Depends}
Description: Common files for PPSSPP
 PPSSPP can run your PSP games on your PC in full HD resolution. It can even 
 upscale textures that would otherwise be too blurry as they were made for 
 the small screen of the original PSP.
 .
 All trademarks are property of their respective owners. The emulator is for 
 educational and development purposes only and it may not be used to play games
 you do not legally own.
 .
 This package provides common files for PPSSPP.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed

export DEB_BUILD_OPTIONS=nocheck

ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)

ifeq ($(ARCH), armhf)
    GLES_ENABLE = -DUSING_GLES2=ON -DUSING_EGL=ON
    # See issue #7817
    #export CC=clang
    #export CXX=clang++
else ifeq ($(ARCH), arm64)
    GLES_ENABLE = -DUSING_GLES2=ON -DUSING_EGL=ON
endif

COMMON_FLAGS = -DUSE_FFMPEG=ON -DUSE_SYSTEM_FFMPEG=OFF -DUSE_SYSTEM_LIBZIP=ON -DUSE_DISCORD=ON -DUSE_WAYLAND_WSI=ON


checkver = $(shell dpkg --compare-versions "$$(dpkg-query --show --showformat '$${Version}' '$(1)')" ge '$(2)' && echo yes || echo no)

ifeq (yes, $(call checkver,libsnappy-dev,1.1.8))
    COMMON_FLAGS += -DUSE_SYSTEM_SNAPPY=ON
endif
#ifeq (yes, $(call checkver,libzip-dev,1.7.3))
#    COMMON_FLAGS += -DUSE_SYSTEM_LIBZIP=ON
#endif
ifeq (yes, $(call checkver,libzstd-dev,1.5.6))
    COMMON_FLAGS += -DUSE_SYSTEM_ZSTD=ON
endif
ifeq (yes, $(call checkver,libminiupnpc-dev,2.2.7))
    COMMON_FLAGS += -DUSE_SYSTEM_MINIUPNPC=ON
endif



%:
	dh $@ --buildsystem=cmake --parallel

override_dh_auto_configure:
ifeq ($(ARCH), i386)
	cd ffmpeg && ./linux_x86.sh
else ifeq ($(ARCH), amd64)
	cd ffmpeg && ./linux_x86-64.sh
else ifeq ($(ARCH), armhf)
	cd ffmpeg && ./linux_armhf.sh
else ifeq ($(ARCH), arm64)
	cd ffmpeg && ./linux_arm64.sh
else ifeq ($(ARCH), riscv64)
	cd ffmpeg && ./linux_riscv64.sh
else ifeq ($(ARCH), loong64)
	cd ffmpeg && ./linux_loongarch64.sh
else ifeq ($(ARCH), mips64el)
	cd ffmpeg && ./linux_mips64.sh
else
	@echo "Unknown ARCH: $(ARCH)"
endif
	dh_auto_configure $@ --builddirectory=obj_sdl -- $(GLES_ENABLE) $(COMMON_FLAGS)

override_dh_auto_build:
	dh_auto_build $@ --builddirectory=obj_sdl

override_dh_auto_install:
	dh_auto_install $@ --builddirectory=obj_sdl

#override_dh_auto_test:
#	dh_auto_test $@ --builddirectory=obj_sdl

override_dh_auto_clean:
	dh_auto_clean $@ --builddirectory=obj_sdl

#override_dh_strip:
#	dh_strip -pppsspp --dbg-package=ppsspp-dbg
#	dh_strip -pppsspp-sdl --dbg-package=ppsspp-sdl-dbg
